# Why ?

We are facing the biggest challenge of mankind history: to make our activities sustainable enough to not jeopardize our future.

![Global average temperature anomaly](https://bpetit.nce.re/temperature-anomaly.svg)

To match the Paris agreement objective of not going further than +2 Celcius degrees on average in 2100, we need to transform our industries.
The tech industry is no exception and we need to make sure that its benefits are not cancelled (or worse) by its negative impact.

Measuring power consumption in tech services infrastructures is not as easy as it seems. We often rely on physical devices to do that and need to build in-house data pipelines to get those metrics useful. Furthermore this doesn't give fine graned data regarding applications/processes power consumption but only the host power consumption.
This is even harder in a virtualization environement or as public cloud customers.

Even [recent](https://www.iea.org/reports/data-centres-and-data-transmission-networks) [scientific](https://www.actu-environnement.com/media/pdf/news-36483-etude-UE-consommation-energie-centre-donnees-cloud.pdf) researches about tech energy consumption rely on statistical, both large and narrowed scale, assumptions based data (because it's all we got). Despite their weaknesses, they also all agree on the fact that the current consumption of datacenters and the Internet will increase drastically in the following years.

Scaphandre aims to initiate a collaboration of tech companies and enthusiasts to provide an easy, lightweight, robust and well understood way to precisely measure the energy consumption and make it useful to take soberness decisions.

Note that the greenhouse gazes emissions related to this energy consumption depends on the energetic mix of your country. You may find valuable data about that on [Electricity Map](https://www.electricitymap.org/map).
